# coding=utf-8
# --------------------------------------------------------------------------
# Copyright (c) Microsoft Corporation. All rights reserved.
# Licensed under the MIT License. See License.txt in the project root for
# license information.
#
# Code generated by Microsoft (R) AutoRest Code Generator.
# Changes may cause incorrect behavior and will be lost if the code is
# regenerated.
# --------------------------------------------------------------------------

from msrest.serialization import Model


class DeployedServicePackageInfo(Model):
    """Information about service package deployed on a Service Fabric node.

    :param name:
    :type name: str
    :param version: The version of the service package specified in service
     manifest.
    :type version: str
    :param status: Possible values include: 'Invalid', 'Downloading',
     'Activating', 'Active', 'Upgrading', 'Deactivating'
    :type status: str or :class:`enum <azure.servicefabric.models.enum>`
    :param service_package_activation_id:
    :type service_package_activation_id: str
    """

    _attribute_map = {
        'name': {'key': 'Name', 'type': 'str'},
        'version': {'key': 'Version', 'type': 'str'},
        'status': {'key': 'Status', 'type': 'str'},
        'service_package_activation_id': {'key': 'ServicePackageActivationId', 'type': 'str'},
    }

    def __init__(self, name=None, version=None, status=None, service_package_activation_id=None):
        self.name = name
        self.version = version
        self.status = status
        self.service_package_activation_id = service_package_activation_id
